"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseFunctionArg = void 0;
var console_messages_1 = require("../../../../cli/console/console.messages");
var translate_graphql_type_to_typescript_1 = require("../../typescript/translate-graphql-type-to-typescript");
var parseFunctionArg = function (_a) {
    var _b, _c, _d, _e, _f, _g;
    var type = _a.type, name = _a.name;
    switch ((_b = type.ofType) === null || _b === void 0 ? void 0 : _b.kind) {
        case 'INPUT_OBJECT':
            return {
                name: name,
                type: type.ofType.name,
                import: (_c = type.ofType.name) !== null && _c !== void 0 ? _c : undefined,
            };
        case 'SCALAR':
            return {
                name: name,
                type: (0, translate_graphql_type_to_typescript_1.translateGraphqlTypeToTypescript)(type.ofType.name),
            };
        case 'LIST': {
            var ofType = (_e = (_d = type.ofType) === null || _d === void 0 ? void 0 : _d.ofType) === null || _e === void 0 ? void 0 : _e.ofType;
            if ((ofType === null || ofType === void 0 ? void 0 : ofType.kind) === 'SCALAR') {
                return {
                    name: name,
                    type: (0, translate_graphql_type_to_typescript_1.translateGraphqlTypeToTypescript)(ofType.name),
                    // type: `Array<${translateGraphqlTypeToTypescript(ofType.name)}>`,
                };
            }
            return {
                name: name,
                type: "Array<".concat(ofType === null || ofType === void 0 ? void 0 : ofType.name, ">"),
                import: (_f = type.ofType.name) !== null && _f !== void 0 ? _f : undefined,
            };
        }
        default:
            (0, console_messages_1.displayWarning)("Query replacer: unhandled arg type ".concat((_g = type.ofType) === null || _g === void 0 ? void 0 : _g.kind, " for query ").concat(name));
            return {
                name: name,
                type: 'unknown',
            };
    }
};
exports.parseFunctionArg = parseFunctionArg;
