"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateQueryReplacer = void 0;
var get_replacer_function_params_1 = require("./args/get-replacer-function-params");
var parse_function_arg_1 = require("./args/parse-function-arg");
var stringify_args_1 = require("./args/stringify-args");
var capitalize_1 = require("../../util/capitalize");
var getArgsTypesImports = function (queryObject) {
    var _a;
    return (_a = queryObject.fields) === null || _a === void 0 ? void 0 : _a.filter(function (el) { return el.args && el.args.length > 0; }).map(function (el) { return "".concat((0, capitalize_1.capitalize)(el.name), "QueryArgs"); });
};
var generateQueryReplacer = function (queryObject) {
    var _a;
    var argsImports = getArgsTypesImports(queryObject);
    var declaration = "".concat(argsImports && (argsImports === null || argsImports === void 0 ? void 0 : argsImports.length) > 0
        ? "import { ".concat(argsImports.join(', '), " } from './../types/api-types';\nimport { stringify } from './stringify-object'\n\n")
        : '', "export const queryReplacer: Record<\nstring,\n// eslint-disable-next-line @typescript-eslint/no-explicit-any\n(variables: any) => [RegExp, string] | undefined\n> = {\n");
    var output = ((_a = queryObject.fields) === null || _a === void 0 ? void 0 : _a.reduce(function (out, _a) {
        var name = _a.name, args = _a.args;
        if ((args === null || args === void 0 ? void 0 : args.length) === 0 || !args) {
            return "".concat(out, "  ").concat(name, ": () => undefined,\n");
        }
        var tsArgs = args.map(parse_function_arg_1.parseFunctionArg);
        var functionParams = (0, get_replacer_function_params_1.getReplacerFunctionParams)(name, tsArgs);
        var stringifiedArgs = (0, stringify_args_1.stringifyArgs)(tsArgs);
        return "".concat(out, "  ").concat(name, ": ").concat(functionParams, " => [new RegExp('^ {2}").concat(name, " {$', 'gm'), `  ").concat(name, "(").concat(stringifiedArgs, ") {`],\n");
    }, declaration)) || '';
    return "".concat(output, "\n};");
};
exports.generateQueryReplacer = generateQueryReplacer;
