"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getQueryFields = void 0;
var chalk_1 = __importDefault(require("chalk"));
var logic_1 = require("./logic");
var console_messages_1 = require("../../../../cli/console/console.messages");
var getQueryFields = function (queryName, name, types, objectsName, enums, booleanize, past) {
    if (past === void 0) { past = []; }
    var properties = (0, logic_1.getTypeProperties)(name, types);
    if (!properties) {
        return { queryImports: [], queryOutput: '' };
    }
    var _a = properties.reduce(function (acc, property) {
        var _a = __read(property.split(':'), 2), propertyName = _a[0], type = _a[1];
        var maybeArrayAnnotation = (0, logic_1.getMaybeArrayAnnotation)(booleanize, type);
        var rawType = (0, logic_1.getRawType)(type);
        if (past.some(function (p) { return p.propertyName === propertyName && p.rawType === rawType; })) {
            if (booleanize) {
                (0, console_messages_1.displayWarning)("Circular reference detected in ".concat(chalk_1.default.whiteBright("".concat(queryName, " query")), ": ignoring property ").concat(chalk_1.default.whiteBright(propertyName), " of type ").concat(chalk_1.default.whiteBright(rawType)));
            }
            return acc;
        }
        var isTypeScalar = !objectsName.includes(rawType);
        if (isTypeScalar) {
            return {
                imports: enums.includes(rawType)
                    ? __spreadArray(__spreadArray([], __read(acc.imports), false), [rawType], false) : acc.imports,
                output: (0, logic_1.formatScalar)(acc.output, property, booleanize, type, maybeArrayAnnotation),
            };
        }
        past.push({ propertyName: propertyName, rawType: rawType });
        var deep = (0, exports.getQueryFields)(queryName, rawType, types, objectsName, enums, booleanize, past);
        var member = "".concat(propertyName).concat(booleanize ? (0, logic_1.setOptional)(propertyName.endsWith('?')) : '', ": ") +
            deep.queryOutput +
            maybeArrayAnnotation +
            ';';
        return {
            output: acc.output + member,
            imports: __spreadArray(__spreadArray([], __read(acc.imports), false), __read(deep.queryImports), false),
        };
    }, { imports: [], output: '' }), imports = _a.imports, output = _a.output;
    return { queryOutput: "{ ".concat(output, " }"), queryImports: imports };
};
exports.getQueryFields = getQueryFields;
